/* boni.c generated by valac 0.32.0.32-d07e8, the Vala compiler
 * generated from boni.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 * Gnome Nibbles: Gnome Worm Game
 * Copyright (C) 2015 Iulian-Gabriel Radu <iulian.radu67@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/* This is a fairly literal translation of the GPLv2+ original by*/
/* Sean MacIsaac, Ian Peters, Guillaume Béland.*/

#include <glib.h>
#include <glib-object.h>
#include <gee.h>


#define TYPE_BONUS_TYPE (bonus_type_get_type ())

#define TYPE_BONUS (bonus_get_type ())
#define BONUS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BONUS, Bonus))
#define BONUS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BONUS, BonusClass))
#define IS_BONUS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BONUS))
#define IS_BONUS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BONUS))
#define BONUS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BONUS, BonusClass))

typedef struct _Bonus Bonus;
typedef struct _BonusClass BonusClass;
typedef struct _BonusPrivate BonusPrivate;

#define TYPE_BONI (boni_get_type ())
#define BONI(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BONI, Boni))
#define BONI_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BONI, BoniClass))
#define IS_BONI(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BONI))
#define IS_BONI_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BONI))
#define BONI_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BONI, BoniClass))

typedef struct _Boni Boni;
typedef struct _BoniClass BoniClass;
typedef struct _BoniPrivate BoniPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

typedef enum  {
	BONUS_TYPE_REGULAR,
	BONUS_TYPE_HALF,
	BONUS_TYPE_DOUBLE,
	BONUS_TYPE_LIFE,
	BONUS_TYPE_REVERSE,
	BONUS_TYPE_WARP
} BonusType;

struct _Bonus {
	GObject parent_instance;
	BonusPrivate * priv;
	gint x;
	gint y;
	BonusType type;
	gboolean fake;
	gint countdown;
};

struct _BonusClass {
	GObjectClass parent_class;
};

struct _Boni {
	GObject parent_instance;
	BoniPrivate * priv;
	GeeLinkedList* bonuses;
	gint missed;
	gint numleft;
	gint numboni;
	gint numbonuses;
};

struct _BoniClass {
	GObjectClass parent_class;
};


static gpointer bonus_parent_class = NULL;
static gpointer boni_parent_class = NULL;

GType bonus_type_get_type (void) G_GNUC_CONST;
GType bonus_get_type (void) G_GNUC_CONST;
enum  {
	BONUS_DUMMY_PROPERTY
};
Bonus* bonus_new (gint x, gint y, BonusType type, gboolean fake, gint countdown);
Bonus* bonus_construct (GType object_type, gint x, gint y, BonusType type, gboolean fake, gint countdown);
static void bonus_finalize (GObject* obj);
GType boni_get_type (void) G_GNUC_CONST;
enum  {
	BONI_DUMMY_PROPERTY
};
#define BONI_MAX_BONUSES 100
#define BONI_MAX_MISSED 2
Boni* boni_new (gint numworms);
Boni* boni_construct (GType object_type, gint numworms);
void boni_add_bonus (Boni* self, gint* board, int board_length1, int board_length2, gint x, gint y, BonusType type, gboolean fake, gint countdown);
void boni_remove_bonus (Boni* self, gint* board, int board_length1, int board_length2, Bonus* bonus);
#define NIBBLES_GAME_EMPTYCHAR 'a'
void boni_reset (Boni* self, gint numworms);
Bonus* boni_get_bonus (Boni* self, gint* board, int board_length1, int board_length2, gint x, gint y);
static void boni_finalize (GObject* obj);


GType bonus_type_get_type (void) {
	static volatile gsize bonus_type_type_id__volatile = 0;
	if (g_once_init_enter (&bonus_type_type_id__volatile)) {
		static const GEnumValue values[] = {{BONUS_TYPE_REGULAR, "BONUS_TYPE_REGULAR", "regular"}, {BONUS_TYPE_HALF, "BONUS_TYPE_HALF", "half"}, {BONUS_TYPE_DOUBLE, "BONUS_TYPE_DOUBLE", "double"}, {BONUS_TYPE_LIFE, "BONUS_TYPE_LIFE", "life"}, {BONUS_TYPE_REVERSE, "BONUS_TYPE_REVERSE", "reverse"}, {BONUS_TYPE_WARP, "BONUS_TYPE_WARP", "warp"}, {0, NULL, NULL}};
		GType bonus_type_type_id;
		bonus_type_type_id = g_enum_register_static ("BonusType", values);
		g_once_init_leave (&bonus_type_type_id__volatile, bonus_type_type_id);
	}
	return bonus_type_type_id__volatile;
}


Bonus* bonus_construct (GType object_type, gint x, gint y, BonusType type, gboolean fake, gint countdown) {
	Bonus * self = NULL;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	BonusType _tmp2_ = 0;
	gboolean _tmp3_ = FALSE;
	gint _tmp4_ = 0;
#line 40 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	self = (Bonus*) g_object_new (object_type, NULL);
#line 42 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp0_ = x;
#line 42 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	self->x = _tmp0_;
#line 43 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp1_ = y;
#line 43 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	self->y = _tmp1_;
#line 44 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp2_ = type;
#line 44 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	self->type = _tmp2_;
#line 45 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp3_ = fake;
#line 45 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	self->fake = _tmp3_;
#line 46 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp4_ = countdown;
#line 46 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	self->countdown = _tmp4_;
#line 40 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	return self;
#line 163 "boni.c"
}


Bonus* bonus_new (gint x, gint y, BonusType type, gboolean fake, gint countdown) {
#line 40 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	return bonus_construct (TYPE_BONUS, x, y, type, fake, countdown);
#line 170 "boni.c"
}


static void bonus_class_init (BonusClass * klass) {
#line 32 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	bonus_parent_class = g_type_class_peek_parent (klass);
#line 32 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	G_OBJECT_CLASS (klass)->finalize = bonus_finalize;
#line 179 "boni.c"
}


static void bonus_instance_init (Bonus * self) {
}


static void bonus_finalize (GObject* obj) {
	Bonus * self;
#line 32 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BONUS, Bonus);
#line 32 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	G_OBJECT_CLASS (bonus_parent_class)->finalize (obj);
#line 193 "boni.c"
}


GType bonus_get_type (void) {
	static volatile gsize bonus_type_id__volatile = 0;
	if (g_once_init_enter (&bonus_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BonusClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) bonus_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Bonus), 0, (GInstanceInitFunc) bonus_instance_init, NULL };
		GType bonus_type_id;
		bonus_type_id = g_type_register_static (G_TYPE_OBJECT, "Bonus", &g_define_type_info, 0);
		g_once_init_leave (&bonus_type_id__volatile, bonus_type_id);
	}
	return bonus_type_id__volatile;
}


Boni* boni_construct (GType object_type, gint numworms) {
	Boni * self = NULL;
	GeeLinkedList* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
#line 65 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	self = (Boni*) g_object_new (object_type, NULL);
#line 67 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp0_ = gee_linked_list_new (TYPE_BONUS, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
#line 67 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_g_object_unref0 (self->bonuses);
#line 67 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	self->bonuses = _tmp0_;
#line 68 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	self->missed = 0;
#line 69 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp1_ = numworms;
#line 69 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	self->numboni = 8 + _tmp1_;
#line 70 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	self->numbonuses = 0;
#line 71 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp2_ = self->numboni;
#line 71 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	self->numleft = _tmp2_;
#line 65 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	return self;
#line 236 "boni.c"
}


Boni* boni_new (gint numworms) {
#line 65 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	return boni_construct (TYPE_BONI, numworms);
#line 243 "boni.c"
}


void boni_add_bonus (Boni* self, gint* board, int board_length1, int board_length2, gint x, gint y, BonusType type, gboolean fake, gint countdown) {
	gint _tmp0_ = 0;
	Bonus* bonus = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	BonusType _tmp3_ = 0;
	gboolean _tmp4_ = FALSE;
	gint _tmp5_ = 0;
	Bonus* _tmp6_ = NULL;
	GeeLinkedList* _tmp7_ = NULL;
	Bonus* _tmp8_ = NULL;
	gint* _tmp9_ = NULL;
	gint _tmp9__length1 = 0;
	gint _tmp9__length2 = 0;
	gint _tmp10_ = 0;
	gint _tmp11_ = 0;
	BonusType _tmp12_ = 0;
	gint _tmp13_ = 0;
	gint* _tmp14_ = NULL;
	gint _tmp14__length1 = 0;
	gint _tmp14__length2 = 0;
	gint _tmp15_ = 0;
	gint _tmp16_ = 0;
	BonusType _tmp17_ = 0;
	gint _tmp18_ = 0;
	gint* _tmp19_ = NULL;
	gint _tmp19__length1 = 0;
	gint _tmp19__length2 = 0;
	gint _tmp20_ = 0;
	gint _tmp21_ = 0;
	BonusType _tmp22_ = 0;
	gint _tmp23_ = 0;
	gint* _tmp24_ = NULL;
	gint _tmp24__length1 = 0;
	gint _tmp24__length2 = 0;
	gint _tmp25_ = 0;
	gint _tmp26_ = 0;
	BonusType _tmp27_ = 0;
	gint _tmp28_ = 0;
	gint _tmp29_ = 0;
#line 74 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	g_return_if_fail (self != NULL);
#line 76 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp0_ = self->numbonuses;
#line 76 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	if (_tmp0_ == BONI_MAX_BONUSES) {
#line 77 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
		return;
#line 295 "boni.c"
	}
#line 79 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp1_ = x;
#line 79 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp2_ = y;
#line 79 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp3_ = type;
#line 79 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp4_ = fake;
#line 79 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp5_ = countdown;
#line 79 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp6_ = bonus_new (_tmp1_, _tmp2_, _tmp3_, _tmp4_, _tmp5_);
#line 79 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	bonus = _tmp6_;
#line 80 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp7_ = self->bonuses;
#line 80 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp8_ = bonus;
#line 80 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp7_, _tmp8_);
#line 81 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp9_ = board;
#line 81 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp9__length1 = board_length1;
#line 81 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp9__length2 = board_length2;
#line 81 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp10_ = x;
#line 81 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp11_ = y;
#line 81 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp12_ = type;
#line 81 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp9_[(_tmp10_ * _tmp9__length2) + _tmp11_] = (gint) (_tmp12_ + 'A');
#line 81 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp13_ = _tmp9_[(_tmp10_ * _tmp9__length2) + _tmp11_];
#line 82 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp14_ = board;
#line 82 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp14__length1 = board_length1;
#line 82 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp14__length2 = board_length2;
#line 82 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp15_ = x;
#line 82 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp16_ = y;
#line 82 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp17_ = type;
#line 82 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp14_[((_tmp15_ + 1) * _tmp14__length2) + _tmp16_] = (gint) (_tmp17_ + 'A');
#line 82 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp18_ = _tmp14_[((_tmp15_ + 1) * _tmp14__length2) + _tmp16_];
#line 83 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp19_ = board;
#line 83 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp19__length1 = board_length1;
#line 83 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp19__length2 = board_length2;
#line 83 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp20_ = x;
#line 83 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp21_ = y;
#line 83 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp22_ = type;
#line 83 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp19_[(_tmp20_ * _tmp19__length2) + (_tmp21_ + 1)] = (gint) (_tmp22_ + 'A');
#line 83 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp23_ = _tmp19_[(_tmp20_ * _tmp19__length2) + (_tmp21_ + 1)];
#line 84 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp24_ = board;
#line 84 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp24__length1 = board_length1;
#line 84 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp24__length2 = board_length2;
#line 84 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp25_ = x;
#line 84 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp26_ = y;
#line 84 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp27_ = type;
#line 84 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp24_[((_tmp25_ + 1) * _tmp24__length2) + (_tmp26_ + 1)] = (gint) (_tmp27_ + 'A');
#line 84 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp28_ = _tmp24_[((_tmp25_ + 1) * _tmp24__length2) + (_tmp26_ + 1)];
#line 85 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	g_signal_emit_by_name (self, "bonus-added");
#line 86 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp29_ = self->numbonuses;
#line 86 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	self->numbonuses = _tmp29_ + 1;
#line 74 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_g_object_unref0 (bonus);
#line 389 "boni.c"
}


void boni_remove_bonus (Boni* self, gint* board, int board_length1, int board_length2, Bonus* bonus) {
	gint* _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gint _tmp0__length2 = 0;
	Bonus* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	Bonus* _tmp3_ = NULL;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	gint* _tmp6_ = NULL;
	gint _tmp6__length1 = 0;
	gint _tmp6__length2 = 0;
	Bonus* _tmp7_ = NULL;
	gint _tmp8_ = 0;
	Bonus* _tmp9_ = NULL;
	gint _tmp10_ = 0;
	gint _tmp11_ = 0;
	gint* _tmp12_ = NULL;
	gint _tmp12__length1 = 0;
	gint _tmp12__length2 = 0;
	Bonus* _tmp13_ = NULL;
	gint _tmp14_ = 0;
	Bonus* _tmp15_ = NULL;
	gint _tmp16_ = 0;
	gint _tmp17_ = 0;
	gint* _tmp18_ = NULL;
	gint _tmp18__length1 = 0;
	gint _tmp18__length2 = 0;
	Bonus* _tmp19_ = NULL;
	gint _tmp20_ = 0;
	Bonus* _tmp21_ = NULL;
	gint _tmp22_ = 0;
	gint _tmp23_ = 0;
	Bonus* _tmp24_ = NULL;
#line 89 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	g_return_if_fail (self != NULL);
#line 89 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	g_return_if_fail (bonus != NULL);
#line 91 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp0_ = board;
#line 91 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp0__length1 = board_length1;
#line 91 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp0__length2 = board_length2;
#line 91 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp1_ = bonus;
#line 91 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp2_ = _tmp1_->x;
#line 91 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp3_ = bonus;
#line 91 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp4_ = _tmp3_->y;
#line 91 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp0_[(_tmp2_ * _tmp0__length2) + _tmp4_] = (gint) NIBBLES_GAME_EMPTYCHAR;
#line 91 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp5_ = _tmp0_[(_tmp2_ * _tmp0__length2) + _tmp4_];
#line 92 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp6_ = board;
#line 92 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp6__length1 = board_length1;
#line 92 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp6__length2 = board_length2;
#line 92 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp7_ = bonus;
#line 92 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp8_ = _tmp7_->x;
#line 92 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp9_ = bonus;
#line 92 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp10_ = _tmp9_->y;
#line 92 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp6_[((_tmp8_ + 1) * _tmp6__length2) + _tmp10_] = (gint) NIBBLES_GAME_EMPTYCHAR;
#line 92 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp11_ = _tmp6_[((_tmp8_ + 1) * _tmp6__length2) + _tmp10_];
#line 93 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp12_ = board;
#line 93 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp12__length1 = board_length1;
#line 93 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp12__length2 = board_length2;
#line 93 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp13_ = bonus;
#line 93 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp14_ = _tmp13_->x;
#line 93 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp15_ = bonus;
#line 93 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp16_ = _tmp15_->y;
#line 93 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp12_[(_tmp14_ * _tmp12__length2) + (_tmp16_ + 1)] = (gint) NIBBLES_GAME_EMPTYCHAR;
#line 93 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp17_ = _tmp12_[(_tmp14_ * _tmp12__length2) + (_tmp16_ + 1)];
#line 94 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp18_ = board;
#line 94 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp18__length1 = board_length1;
#line 94 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp18__length2 = board_length2;
#line 94 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp19_ = bonus;
#line 94 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp20_ = _tmp19_->x;
#line 94 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp21_ = bonus;
#line 94 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp22_ = _tmp21_->y;
#line 94 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp18_[((_tmp20_ + 1) * _tmp18__length2) + (_tmp22_ + 1)] = (gint) NIBBLES_GAME_EMPTYCHAR;
#line 94 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp23_ = _tmp18_[((_tmp20_ + 1) * _tmp18__length2) + (_tmp22_ + 1)];
#line 96 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp24_ = bonus;
#line 96 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	g_signal_emit_by_name (self, "bonus-removed", _tmp24_);
#line 507 "boni.c"
}


void boni_reset (Boni* self, gint numworms) {
	GeeLinkedList* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
#line 99 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	g_return_if_fail (self != NULL);
#line 101 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp0_ = self->bonuses;
#line 101 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
#line 102 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	self->missed = 0;
#line 103 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp1_ = numworms;
#line 103 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	self->numboni = 8 + _tmp1_;
#line 104 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	self->numbonuses = 0;
#line 105 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_tmp2_ = self->numboni;
#line 105 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	self->numleft = _tmp2_;
#line 533 "boni.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 110 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	return self ? g_object_ref (self) : NULL;
#line 540 "boni.c"
}


Bonus* boni_get_bonus (Boni* self, gint* board, int board_length1, int board_length2, gint x, gint y) {
	Bonus* result = NULL;
#line 108 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 548 "boni.c"
	{
		GeeLinkedList* _bonus_list = NULL;
		GeeLinkedList* _tmp0_ = NULL;
		GeeLinkedList* _tmp1_ = NULL;
		gint _bonus_size = 0;
		GeeLinkedList* _tmp2_ = NULL;
		gint _tmp3_ = 0;
		gint _tmp4_ = 0;
		gint _bonus_index = 0;
#line 110 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
		_tmp0_ = self->bonuses;
#line 110 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 110 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
		_bonus_list = _tmp1_;
#line 110 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
		_tmp2_ = _bonus_list;
#line 110 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp2_);
#line 110 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
		_tmp4_ = _tmp3_;
#line 110 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
		_bonus_size = _tmp4_;
#line 110 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
		_bonus_index = -1;
#line 110 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
		while (TRUE) {
#line 576 "boni.c"
			gint _tmp5_ = 0;
			gint _tmp6_ = 0;
			gint _tmp7_ = 0;
			Bonus* bonus = NULL;
			GeeLinkedList* _tmp8_ = NULL;
			gint _tmp9_ = 0;
			gpointer _tmp10_ = NULL;
			gboolean _tmp11_ = FALSE;
			gboolean _tmp12_ = FALSE;
			gboolean _tmp13_ = FALSE;
			gboolean _tmp14_ = FALSE;
			gint _tmp15_ = 0;
			Bonus* _tmp16_ = NULL;
			gint _tmp17_ = 0;
#line 110 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
			_tmp5_ = _bonus_index;
#line 110 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
			_bonus_index = _tmp5_ + 1;
#line 110 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
			_tmp6_ = _bonus_index;
#line 110 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
			_tmp7_ = _bonus_size;
#line 110 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
			if (!(_tmp6_ < _tmp7_)) {
#line 110 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
				break;
#line 603 "boni.c"
			}
#line 110 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
			_tmp8_ = _bonus_list;
#line 110 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
			_tmp9_ = _bonus_index;
#line 110 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _tmp9_);
#line 110 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
			bonus = (Bonus*) _tmp10_;
#line 112 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
			_tmp15_ = x;
#line 112 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
			_tmp16_ = bonus;
#line 112 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
			_tmp17_ = _tmp16_->x;
#line 112 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
			if (_tmp15_ == _tmp17_) {
#line 621 "boni.c"
				gint _tmp18_ = 0;
				Bonus* _tmp19_ = NULL;
				gint _tmp20_ = 0;
#line 112 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
				_tmp18_ = y;
#line 112 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
				_tmp19_ = bonus;
#line 112 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
				_tmp20_ = _tmp19_->y;
#line 112 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
				_tmp14_ = _tmp18_ == _tmp20_;
#line 633 "boni.c"
			} else {
#line 112 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
				_tmp14_ = FALSE;
#line 637 "boni.c"
			}
#line 112 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
			if (_tmp14_) {
#line 112 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
				_tmp13_ = TRUE;
#line 643 "boni.c"
			} else {
				gboolean _tmp21_ = FALSE;
				gint _tmp22_ = 0;
				Bonus* _tmp23_ = NULL;
				gint _tmp24_ = 0;
#line 113 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
				_tmp22_ = x;
#line 113 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
				_tmp23_ = bonus;
#line 113 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
				_tmp24_ = _tmp23_->x;
#line 113 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
				if (_tmp22_ == (_tmp24_ + 1)) {
#line 657 "boni.c"
					gint _tmp25_ = 0;
					Bonus* _tmp26_ = NULL;
					gint _tmp27_ = 0;
#line 113 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
					_tmp25_ = y;
#line 113 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
					_tmp26_ = bonus;
#line 113 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
					_tmp27_ = _tmp26_->y;
#line 113 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
					_tmp21_ = _tmp25_ == _tmp27_;
#line 669 "boni.c"
				} else {
#line 113 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
					_tmp21_ = FALSE;
#line 673 "boni.c"
				}
#line 113 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
				_tmp13_ = _tmp21_;
#line 677 "boni.c"
			}
#line 112 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
			if (_tmp13_) {
#line 112 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
				_tmp12_ = TRUE;
#line 683 "boni.c"
			} else {
				gboolean _tmp28_ = FALSE;
				gint _tmp29_ = 0;
				Bonus* _tmp30_ = NULL;
				gint _tmp31_ = 0;
#line 114 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
				_tmp29_ = x;
#line 114 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
				_tmp30_ = bonus;
#line 114 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
				_tmp31_ = _tmp30_->x;
#line 114 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
				if (_tmp29_ == _tmp31_) {
#line 697 "boni.c"
					gint _tmp32_ = 0;
					Bonus* _tmp33_ = NULL;
					gint _tmp34_ = 0;
#line 114 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
					_tmp32_ = y;
#line 114 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
					_tmp33_ = bonus;
#line 114 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
					_tmp34_ = _tmp33_->y;
#line 114 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
					_tmp28_ = _tmp32_ == (_tmp34_ + 1);
#line 709 "boni.c"
				} else {
#line 114 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
					_tmp28_ = FALSE;
#line 713 "boni.c"
				}
#line 114 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
				_tmp12_ = _tmp28_;
#line 717 "boni.c"
			}
#line 112 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
			if (_tmp12_) {
#line 112 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
				_tmp11_ = TRUE;
#line 723 "boni.c"
			} else {
				gboolean _tmp35_ = FALSE;
				gint _tmp36_ = 0;
				Bonus* _tmp37_ = NULL;
				gint _tmp38_ = 0;
#line 115 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
				_tmp36_ = x;
#line 115 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
				_tmp37_ = bonus;
#line 115 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
				_tmp38_ = _tmp37_->x;
#line 115 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
				if (_tmp36_ == (_tmp38_ + 1)) {
#line 737 "boni.c"
					gint _tmp39_ = 0;
					Bonus* _tmp40_ = NULL;
					gint _tmp41_ = 0;
#line 115 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
					_tmp39_ = y;
#line 115 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
					_tmp40_ = bonus;
#line 115 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
					_tmp41_ = _tmp40_->y;
#line 115 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
					_tmp35_ = _tmp39_ == (_tmp41_ + 1);
#line 749 "boni.c"
				} else {
#line 115 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
					_tmp35_ = FALSE;
#line 753 "boni.c"
				}
#line 115 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
				_tmp11_ = _tmp35_;
#line 757 "boni.c"
			}
#line 112 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
			if (_tmp11_) {
#line 117 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
				result = bonus;
#line 117 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
				_g_object_unref0 (_bonus_list);
#line 117 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
				return result;
#line 767 "boni.c"
			}
#line 110 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
			_g_object_unref0 (bonus);
#line 771 "boni.c"
		}
#line 110 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
		_g_object_unref0 (_bonus_list);
#line 775 "boni.c"
	}
#line 121 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	result = NULL;
#line 121 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	return result;
#line 781 "boni.c"
}


static void boni_class_init (BoniClass * klass) {
#line 50 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	boni_parent_class = g_type_class_peek_parent (klass);
#line 50 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	G_OBJECT_CLASS (klass)->finalize = boni_finalize;
#line 50 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	g_signal_new ("bonus_added", TYPE_BONI, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 50 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	g_signal_new ("bonus_removed", TYPE_BONI, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_BONUS);
#line 794 "boni.c"
}


static void boni_instance_init (Boni * self) {
}


static void boni_finalize (GObject* obj) {
	Boni * self;
#line 50 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BONI, Boni);
#line 52 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	_g_object_unref0 (self->bonuses);
#line 50 "/home/mcatanzaro/src/jhbuild/checkout/gnome-nibbles/src/boni.vala"
	G_OBJECT_CLASS (boni_parent_class)->finalize (obj);
#line 810 "boni.c"
}


GType boni_get_type (void) {
	static volatile gsize boni_type_id__volatile = 0;
	if (g_once_init_enter (&boni_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BoniClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) boni_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Boni), 0, (GInstanceInitFunc) boni_instance_init, NULL };
		GType boni_type_id;
		boni_type_id = g_type_register_static (G_TYPE_OBJECT, "Boni", &g_define_type_info, 0);
		g_once_init_leave (&boni_type_id__volatile, boni_type_id);
	}
	return boni_type_id__volatile;
}



